<?php
include("./include/phplib/prepend.php3");
$cancel_login = 1;
page_open(array("sess" => "Thesaurus_Session", "auth" => "Thesaurus_Default_Auth"));
$title = "Dokumentácia";
$page = "faq";
include("./include/top.php");
?>

<?php
$q_list = array();
$a_list = array();
$name_list = array();

addFAQ("Úvod",
	'<p>Projekt OpenThesaurus je PHP/MySQL web rozhranie, ktoré umožňuje
	spoluprácu viacerých ľudí na tvorbe synonymického slovníka. Projekt
       	umožňuje export do týchto formátov: OpenOffice.org, KWord a prostý
	text.</p>

	<p>Ako základ pre Otvorený Slovenský Synonymický Slovník boli použité
	dáta z českého projektu	(http://nlp.fi.muni.cz/projekty/czthes/), ktoré
	preložil a zrevidoval Tibor Bako.</p>

	<p>Ktokoľvek môže kontrolovať tieto údaje, opravovať chyby, alebo
	vkladať nové synonymá. Vyhľadávanie hľadá všetky významy, v
	ktorých sa dané slovo objaví. Ak slovo nie je nádejné, je vám
	ponúknuté, aby ste toto slovo vložili do slovníka.</p>

	<p>Aby ste mohli začal spolupracovať na tomto projekte, musíte sa
	<a href="register.php">zaregistrovať</a>. Predtým je však dôležité,
	aby ste si prečítali túto dokumentáciu dokonca, aby ste spoznali 
	niektoré pravidlá.</p>

	<p>Skôr ako vložíte alebo zmeníte nejakú položku musíte pochopiť, ako
	sú dáta v slovníku štruktúrované - podľa významu. Napríklad slovo 
	<bsp>agent</bsp> môže byť význame <em>sprostredkovateľ</em>
	(poistenia), alebo vo význame <em>vyzvedač</em>. Pritom slová
	sprostredkovateľ a špión synonymami nie sú. Preto pre agenta musia v
	slovníku existovať dva synonymické rady (významy):  v jednom bude slovo
	sprostredkovať a v druhom bude špión.</p>
	
	<p>V prípade, že hľadané slovo má viac významov, tak sa za ním zobrazí
	číslo, ktorá vyjadruje počet definícií. Kliknutím na neho sa vám
	zobrazia všetky významy.</p>');

addFAQ("Čo je to synonymum?",
	'<p>Ak dve alebo viac slov majú v istom kontexte rovnaký význam, tak
	ich hovoríme, že sú to synonymá. Napríklad:</p>
	
	<p><bsp>agresívny</bsp>, <bsp>útočný</bsp><br />
	<bsp>nemravný</bsp>, <bsp>neslušný</bsp>, <bsp>obscénny</bsp><br />
	<bsp>žalobaba</bsp>, <bsp>donášač</bsp>
	</p>
	
	<p>Synonymá vytvárajú <em>synonymické rady</em> - skupiny slov s
	rovnakým významom. Preto sa slová s rôznym významom -- ako napríklad
	<bsp>agent</bsp> -- objavujú vo viacerých skupinách synonym:</p>
	
	<p>Synonymická skupina 1: <span class="bsp">agent, sliedič, vyzvedač,
	špión</span><br />
	Synonymická skupina 2: <span class="bsp">agent, sprostredkovateľ, zástupca</span></p>
	
	<p>Poznámka pre expertov: Angličtina pre synonymické rady používa
	označenie <em>synsets</em> (<a
	href="http://www.cogsci.princeton.edu/~wn/">WordNet</a>).</p>',"syn");

addFAQ("Čo by som mal brať do úvahy, keď chcem niečo vložiť alebo zmeniť?",
	'<p>V skratke:</p>
	<ul>
		<li>V našom úmysle je vytvoriť <strong>otvorený a
		slobodný</strong> slovník. Z tohoto dôvodu nesmú byť do
		databázy vkladané dáta, ktoré neumožňujú voľné šírenie (t.j.
		prepisovanie slov z existujúcich databáz, či už v elektronickej
		alebo inej forme, ktoré sú chránené proti neautorizovanému
		šíreniu).</li>
		
		<li>Používajte iba slovenské slová. Cudzojazyčné slová
		používajte iba v prípade, ak sú často používané. Nemá zmysel
		vytvoriť dlhý synonymický rad, z ktoré väčšinu slov nie je
		možné použiť v bežnom texte.</li>

		<li>Nevkladajte skratky.</li>
		
		<li>Pred vložením dát, skontrolujte pravopis. Slovník
		momentálne nemá kontrolu pravopisu pri vkladaní údajov do
		databázy.</li>

		<li>Pokiaľ to nie je nutné, tak nepoužívajte viacslovné
		spojenia. Napríklad: nemá zmysel vkladať výraz <span
		class="bsp">rozpočet na reklamu</span>, ak už slovník obsahuje
		synonymá pre slovo <span class="bsp">rozpočet</span>.</li>
		
		<li>Nevkladajte do databázy názvy miest (dedín, údolí... ;-) ),
		firiem a podobne.</li>
		<li>Nevkladajte zastaralé slová.</li>
		<li>Pokiaľ vám chýba nejaká kategória, tak mi napíšte:
		('.EMAIL.'), rád ju doplním.</li>
	</ul>', 'korr');

addFAQ("Čo to znamená <em>v základnom</em> tvare?",
	'<p>Do databázy majú byť vkladané slová v základnom tvare tzn. slovesá
	v neurčitku, podstatné mená v jednotnom čísle a prvom páde, prídavné
	mená v prvom stupni. Napríklad:</p>
	
	<p>
	správne: <bsp>bežať</bsp>, nesprávne: <bsp>bežal</bsp><br />
	správne: <bsp>dom</bsp>, nesprávne: <bsp>domy</bsp><br />
	správne: <bsp>dlhý</bsp>, nesprávne: <bsp>dlhší</bsp><br />
	</p>',
	"grundform");

addFAQ("Prečo sa musím zaregistrovať?",
	'<p>Registrácia je nutná, kvôli súhlasu s podmienkami projektu. Pokiaľ
	nemáte v úmysle zapisovať do databázy, nemusíte sa registrovať.</p>',
       	'register');

$filename_ooo = "download/" . TARGET_OOO . ".zip";
$fp = fopen($filename_ooo, "r");
$s_array = fstat($fp);
fclose($fp);
$date_ooo = strftime("%Y-%m-%d %H:%M", $s_array["mtime"]);
$size_ooo = sprintf("%.0f", $s_array["size"]/1000);

$filename_ooo_new = "download/" . TARGET_OOO2 . ".zip";
$fp = fopen($filename_ooo_new, "r");
$s_array = fstat($fp);
fclose($fp);
$date_ooo_new = strftime("%Y-%m-%d %H:%M", $s_array["mtime"]);
$size_ooo_new = sprintf("%.0f", $s_array["size"]/1000);

$filename_ooo_oxt = "download/" . TARGET_OOO3 . ".oxt";
$fp = fopen($filename_ooo_oxt, "r");
$s_array = fstat($fp);
fclose($fp);
$date_ooo_oxt = strftime("%Y-%m-%d %H:%M", $s_array["mtime"]);
$size_ooo_oxt = sprintf("%.0f", $s_array["size"]/1000);

$filename_php = "download/openthesaurus-sk.tar.bz2";
$fp = fopen($filename_php, "r");
$s_array = fstat($fp);
fclose($fp);
$date_php = strftime("%Y-%m-%d %H:%M", $s_array["mtime"]);
$size_php = sprintf("%.0f", $s_array["size"]/1000);

$filename_dump = "download/thesaurus_dump.sql.gz";
$fp = fopen($filename_dump, "r");
$s_array = fstat($fp);
fclose($fp);
$date_dump = strftime("%Y-%m-%d %H:%M", $s_array["mtime"]);
$size_dump = sprintf("%.0f", $s_array["size"]/1000);

$filename_m = "download/ot-sk_manual.pdf";
$fp = fopen($filename_m, "r");
$s_array = fstat($fp);
fclose($fp);
$date = strftime("%Y-%m-%d %H:%M", $s_array["mtime"]);
$size = sprintf("%.0f", $s_array["size"]/1000);

$filename_txt = "./download/" . TARGET_TEXT . ".gz";
$fp = fopen($filename_txt, "r");
$s_array = fstat($fp);
fclose($fp);
$date_txt = strftime("%Y-%m-%d %H:%M", $s_array["mtime"]);
$size_txt = sprintf("%.0f", $s_array["size"]/1000);

$filename_kword = "./download/" . TARGET_KWORD . ".gz";
$fp = fopen($filename_kword, "r");
$s_array = fstat($fp);
fclose($fp);
$date_kword = strftime("%Y-%m-%d %H:%M", $s_array["mtime"]);
$size_kword = sprintf("%.0f", $s_array["size"]/1000);

// TODO: include("./include/download.php") ?
addFAQ("Na stiahnutie",
	"<p>Tieto dáta je možné šíriť v zmysle tejto <a	href=\"licence.html\">licencie</a>.</p>

	<ul>
		<li><a href=\"$filename_ooo\"><strong>Slovenské dáta pre
		synonymický slovník programu OpenOffice.org 1.x</strong> ($size_ooo KB, generované $date_ooo)</a><br />
			Poznámka: Tieto súbory správne fungujú iba v slovenskej
			verzií programu <a
			href=\"ftp://ftp.linux.cz/pub/localization/OpenOffice.org/devel/645/1.1.4/\">
			OpenOffice 1.1.4</a>.
			Nižšie verzie nedokážu správne pracovať s niektorými
			písmenami, a preto veľa synonym nie je nájdených prípadne
			zle zobrazených. Inštalácia je popísaná v README
			súbore.</li>

		<li><a href=\"$filename_ooo_new\"><strong>Slovenské dáta pre
		synonymický slovník programu OpenOffice.org 2.x</strong> ($size_ooo_new KB, generované $date_ooo_new)</a><br /></li>
		<li><a href=\"http://www.sk-spell.sk.cx/file_download/53/Slovak-Thesaurus.oxt\"><strong>Rozšírenie so slovenskými dátami pre synonymický slovník programu OpenOffice.org (3.0 a novší)</strong> ($size_ooo_oxt KB, generované $date_ooo_oxt)</a> - generuje sa denne. Toto rozšírenie <strong>nepoužívajte</strong> v kombinácií s rozšírením <a href=\"http://extensions.services.openoffice.org/project/dict-sk\">„Slovak dictionary package / Slovenské slovníky“</a>, keďže oba rozšírenia obsahujú dáta pre thesaurus. Namiesto neho si nainštalujte <a href=\"http://www.sk-spell.sk.cx/file_download/55/sk-spell-hyph.oxt\">„rozšírenie iba s kontrolou preklepov a delením slov“</a> (bez synonymického slovníka).<br/></li>
			
		<li><a href=\"$filename_txt\">Synonymický slovník v textovom
		formáte	(komprimovaný, $size_txt KB, vygenerovaný $date_txt</a>,
			použiteľný napr. s <a
			href=\"http://www-user.tu-chemnitz.de/~fri/ding/\">Ding</a>.
			</li>
			
		<li><a href=\"$filename_kword\">Synonymický slovník pre KWord
		min. verzia 1.3beta1
			(komprimovaný, $size_kword KB, vygenerovaný $date_kword</a>).
			Inštalácia: rozbaľte súbor do priečinku
			\$KDEDIR/share/apps/thesaurus/ a potom v KThesaurus
			vyberte zmeňte jazyk.</li>
		<li>Pre vývojárov: <a href=\"$filename_dump\">MySQL-dump
			($size_dump KB, vygenerovaný $date_dump)</a>. PHP kód projektu si 
			môžete stiahnuť <a href=\"$filename_php\">tu
			($size_php KB, vygenerovaný $date_php)</a>.</li>
		<li>Krátky <a href=\"$filename_m\">manuál</a>
			($size KB, umiestnený $date) - ako vkladať nové
			synonymá. Bol som dosť prekvapený, koľko námahy ma to
			stálo, kým so ho dostal aspoň do tohoto stavu :-O. Uvítam každé
			vylepšenie (napr. vhodnejšie obrázky so šírkou 425
			bodov).</li>
			
	</ul>",
	"ooo");

addFAQ("Čo sú to „Wikipedia-odkazy“?",
	'<p>V časti pre Wikipédiu sú odkazy, ktoré s textom súvisia. Vzhľadom k tomu, 
	že Wikipédia je encyklopédia a nie slovník, budú sa tu zobrazovať zobrazovať
	hlavne podstatné mená, a nie slovesá alebo prídavné mená.</p>', 'wikilinks');

addFAQ("Je implementovaná kontrola preklepov?",
	'<p>Kontrola preklepov (spellcheck) je integrovaná čiastočne — pri prehľade (overview) 
	slova (pozri napr. slovo <a href=overview.php?word=proces>proces</a>).
	Kontrola je vykonávaná pomocou projektu http://aspell.net.</p>
	Pokiaľ ste presvedčený, že slovo je napísané správne po slovensky, pošlite chybové hlásenie
	na '.EMAIL.' — pomôžete tým k rozšíreniu slovníkovej zásoby pre aspell-sk.', 'spellcheck');


addFAQ("Môžem integrovať vyhľadávanie v slovníku do svojej stránky?",
	'<p>S nasledujúcim HTML je možné integrovať vyhľadávanie do Vašich stránok:</p>
		<pre>
	&lt;form action="http://www.sk-spell.sk.cx/thesaurus/overview.php" method="get">
		&lt;input type="hidden" name="search" value="1" />
		&lt;input type="text" size="18" name="word" />
		&lt;input type="submit" value="Synonymá…" />
	&lt;/form>
	</pre>',
	'htmlform');

addFAQ("O čom je funkcia podradený/nadradený?",
	'<p>Je mi ľúto, ale táto časť dokumentácie ešte nie je pripravená...</p>',
	'hierarchie');

$at = '<img src="/images/sign.png" width="10" height="10" alt="" />';
addFAQ("Kto mi odpovie na moje otázky?",
	'<p>Skúste napísať mi napísať:-): Zdenko Podobný ('.EMAIL.'). Ak budem
	stíhať, tak odpíšem.');

addFAQ("Prispievatelia",
	'<p>Vďaka patrí Tiborovi Bakovi za počiatočnú verziu dát, Jurajovi
	Bednárovi za poskytnutie priestoru na servery.</p>');

	// TODO: link <a href="http://sourceforge.net/projects/openthesaurus/">...</a>

// ------------------------------------------------

function addFAQ($q, $a, $name="") {
	global $q_list, $a_list, $name_list;
	$q = preg_replace("/<bsp>/", '<span class="bsp">', $q);
	$q = preg_replace("/<\/bsp>/", '</span>', $q);
	$a = preg_replace("/<bsp>/", '<span class="bsp">', $a);
	$a = preg_replace("/<\/bsp>/", '</span>', $a);
	array_push($q_list, $q);
	array_push($a_list, $a);
	array_push($name_list, $name);
}
?>

<?php
$bgcol = "#dddddd";
$style = 'style="padding:2px;%;background-color:'.$bgcol.'"';

// TOC:
print "<strong $style>Obsah</strong>";
print "<ul>";
$i = 0;
foreach($q_list as $item) {
	$name = $name_list[$i];
	if( ! $name ) {
		$name = "item$i";
	}
	print "<li><a href=\"#$name\">$item</a></li>\n";
	$i++;
}
print "</ul>";
?>

<?php
// Content:
$i = 0;
foreach($q_list as $item) {
	$name = $name_list[$i];
	if( ! $name ) {
		$name = "item$i";
	}
	print "<p style=\"margin-top:40px;\"><a name=\"$name\"><strong $style>$item</strong></a></p>\n";
	print $a_list[$i]."\n\n";
	$i++;
}
?>
<br />
<p><i>Aktualizované: 17-01-2009</i></p>

<?php include("./include/textads_faq.php"); ?>

<!-- enables scrolling to the bottom entries: -->
<br/>

<?php include("./include/bottom.php"); ?>
